/[MITgcm]/MITgcm/verification/testscript
ViewVC logotype

Diff of /MITgcm/verification/testscript

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11 by adcroft, Fri Aug 10 18:18:52 2001 UTC revision 1.17 by heimbach, Tue Aug 21 15:21:10 2001 UTC
# Line 122  genmakemodel() Line 122  genmakemodel()
122   ( cd $1;   ( cd $1;
123     if [ $quick -eq 0 -o ! -r Makefile ]; then     if [ $quick -eq 0 -o ! -r Makefile ]; then
124      printf 'genmake ... ' 1>&2      printf 'genmake ... ' 1>&2
125      ../../../tools/genmake -ieee -mods=../code > make.log 2>&1      if [ $ieee -eq 0 ]; then
126         ../../../tools/genmake -mods=../code > make.log 2>&1
127        else
128         ../../../tools/genmake -ieee -mods=../code > make.log 2>&1
129        fi
130      if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
131       tail make.log       tail make.log
132       echo genmakemodel: genmake failed 1>&2       echo genmakemodel: genmake failed 1>&2
# Line 139  makeclean() Line 143  makeclean()
143  # makedependmodel directory  # makedependmodel directory
144   ( cd $1;   ( cd $1;
145     if [ $clean -gt 0 ]; then     if [ $clean -gt 0 ]; then
146        rm -f output.txt
147      printf 'make clean ... ' 2>&1      printf 'make clean ... ' 2>&1
148      make CLEAN >> make.log 2>&1      make CLEAN >> make.log 2>&1
149      if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
# Line 197  runmodel() Line 202  runmodel()
202    
203   ( cd $1   ( cd $1
204     if [ -x $2 ]; then     if [ -x $2 ]; then
205      if [ ! -r output.txt -o $quick -eq 0 ]; then      if [ $quick -eq 0 ]; then
206       echo runmodel: running... 1>&2       rm -f output.txt
      ( ./$2 > output.txt 2>&1 ) && return 0  
      return 1  
     else  
      echo runmodel: output.txt is newer than executable 1>&2  
      return 0  
207      fi      fi
208     else      echo -n "runmodel: " 1>&2
209      echo runmodel: executable \"$1/$2\" is missing 1>&2      make output.txt && return 0
210      return 1  #   if [ ! -r output.txt -o $quick -eq 0 ]; then
211    #    echo runmodel: running... 1>&2
212    #    ( ./$2 > output.txt 2>&1 ) && return 0
213    #    rm -f output.txt
214    #    ( make output.txt ) && return 0
215    #    return 1
216    #   else
217    #    echo runmodel: output.txt is newer than executable 1>&2
218    #    ( make output.txt ) && return 0
219    #    return 0
220    #   fi
221    #  else
222    #   echo runmodel: executable \"$1/$2\" is missing 1>&2
223    #   return 1
224     fi     fi
225   )   )
226  }  }
# Line 282  $0 [-help] [-quick] [-verbose] dir1 [dir Line 295  $0 [-help] [-quick] [-verbose] dir1 [dir
295   -debug     Produce even more output which will mean nothing to most   -debug     Produce even more output which will mean nothing to most
296   -clean     Do "make CLEAN" before compiling. This forces a complete rebuild.   -clean     Do "make CLEAN" before compiling. This forces a complete rebuild.
297   -longtest  Compare numeric output for mean and s.d. of variables.   -longtest  Compare numeric output for mean and s.d. of variables.
298     -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.
299    
300  Normal usage:  Normal usage:
301   $0 *       Configure, compile, run and analyze in all experiment directories   $0 *       Configure, compile, run and analyze in all experiment directories
# Line 309  debug=0 Line 323  debug=0
323  verbose=1  verbose=1
324  quick=0  quick=0
325  clean=0  clean=0
326    ieee=1
327  longtest=0  longtest=0
328  expts=''  expts=''
329    
# Line 320  do Line 335  do
335     -verbose) verbose=2;;     -verbose) verbose=2;;
336     -debug) debug=1;;     -debug) debug=1;;
337     -clean) clean=1;;     -clean) clean=1;;
338       -noieee) ieee=0;;
339     -longtest) longtest=1;;     -longtest) longtest=1;;
340     -quiet) verbose=0;;     -quiet) verbose=0;;
341     -help) show_help; exit 0;;     -help) show_help; exit 0;;
342       -*) echo Unrecognized option:$arg; exit 9;;
343     *) test -d $arg && expts=`echo $expts $arg`;;     *) test -d $arg && expts=`echo $expts $arg`;;
344   esac   esac
345  done  done
346    
347    if [ $clean -gt 0 -a $quick -gt 0 ]; then
348     echo You specified -quick and -clean together which conflict.
349     echo Please specify either -quick or -clean or neither but not both.
350     exit 1
351    fi
352    
353  #if [ ${#expts} -eq 0 ]; then  #if [ ${#expts} -eq 0 ]; then
354  # echo Scanning all directories  # echo Scanning all directories
355  # for arg in *  # for arg in *
# Line 367  do Line 390  do
390   echo Experiment: $dir   echo Experiment: $dir
391   echo   echo
392   unset genmake makedepend make run   unset genmake makedepend make run
393   results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'   if [ $longtest -gt 0 ]; then
394   results='-- -- -- -- -- -- -- -- --'    results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
395     else
396      results='-- -- -- -- -- -- -- -- --'
397     fi
398   genmakemodel $dir/input && genmake=Y \   genmakemodel $dir/input && genmake=Y \
399   && makeclean $dir/input \   && makeclean $dir/input \
400   && makedependmodel $dir/input && makedepend=Y \   && makedependmodel $dir/input && makedepend=Y \
401   && makemodel $dir/input && make=Y \   && makemodel $dir/input && make=Y \
402   && runmodel $dir/input mitgcmuv && run=Y \   && runmodel $dir/input mitgcmuv && run=Y \
403   && results=`testoutput $dir`   && results=`testoutput $dir` \
404     && makeclean $dir/input
405   echo   echo
406   formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results   formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results
407   echo   echo

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.17

  ViewVC Help
Powered by ViewVC 1.1.22